(* broken_types.ml: attempting to restrict argument types of object
   methods does not work in ocaml: the method will always accept the
   most general type *)

open Printf;;

class virtual animal =                   (* virtual: some methods un-implementd *)
object(this)                             (* refer to object via 'this' *)
  method virtual id  : unit -> string    (* method not implemented *)
  method sees (that : animal) =          (* animal argument *)
    printf "%s sees %s: nothing special\n"
           (this#id ()) (that#id ())
end;;

class rabbit =
object(this) inherit animal
  method id () = "rabbit"
  method sees (that : rabbit) =          (* despite specifying rabbit, that can be any animal *)
    printf "rabbit sees %s: more rabbits soon\n" (that#id ())
end;;

class wolf =
object(this) inherit animal
  method id () = "wolf"
  method sees (that : rabbit) =
    printf "wolf sees %s: yum yum\n" (that#id ())
end;;

let _ =
  let a1 = ((new wolf)   :> animal) in
  let a2 = ((new rabbit) :> animal) in
  printf "a1: id is %s\n" (a1#id ());    (* prints unexpected results *)
  printf "a2: id is %s\n" (a2#id ());
  a1#sees a1;
  a1#sees a2;
  a2#sees a2;
;;
  
